
--[[ Copy the code below into a .bat to automate release :

@echo off
set version=V07b1
set name=BayWatchVolley
set sevenzip=C:\Program Files\7-Zip\7z.exe
COLOR 4C
echo.

if not exist "../../%name%%version%.zip" goto freearchname
echo. Error: %name%%version%.zip already exists!
goto end
:freearchname

if not exist "../%name%%version%.exe" goto freeexename
echo. Error: %name%%version%.exe already exists!
goto end
:freeexename

if exist data.zip del data.zip

echo.
echo. 1) Zipping data!
"%sevenzip%" a data.zip main.lua img\
echo.
echo. 2) Moving data!
move /y data.zip ../%name%.love
cd ..
echo.
echo. 3) Merging data with love!
copy /b love.exe+%name%.love "%name%%version%.exe"
echo.
echo. 4) Zipping game release!
"%sevenzip%" a "../%name%%version%.zip" "%name%%version%.exe" DevIL.dll OpenAL32.dll SDL.dll
echo.
echo. 5) Deleting temp files!
rem del data.zip
del "%name%%version%.exe"
move /y %name%.love ../%name%.love
echo.
echo. 6) All done!
:end
echo.
pause

]]--

local socket = require("socket")

local udp=nil
local master=false
local slave=false
local packet_timeout=0
local default_port=23515
local show_network_data = false
local Send,Receive = false,false

local TotalTime = 0
local DeltaTime = 1

local human=1

local balls={{x=300,y=50,a=0,s=0.5,dx=0,dy=0,da=-90}}

local focus = nil
local stdout = false
local devmode = false
local pause = false
local chat = {buffer={},timeout=10,maxline=40}

local ground=187
local players={{x=228,y=ground,score=0,h1=0,h2=90},{x=772,y=ground,score=0,h1=0,h2=-90}}

local blink = true

local Font12,Font24

local round = function(t) return math.floor(t+0.5) end
local rad = function(a) return (a or 0)*math.pi/180 end
local deg = function(a) return (a or 0)*180/math.pi end
local cos = function(a) return math.cos(rad(a)) end
local sin = function(a) return math.sin(rad(a)) end
local atan2 = function(b,a) return deg(math.atan2(b,a)) end
local xor = function(a,b) return (a and not b) or (b and not a) end

local function AddLine(text,color)
	table.insert(chat.buffer,{text=text,color=color or {128,255,255},time=love.timer.getTime()})
	if #chat.buffer>chat.maxline then
		table.remove(chat.buffer,1)
	end
end

local function PrefixBySpaces(n,k)
	local s=""..n
	while s:len()<k do
		s=" "..s
	end
	if s:len()~=4 then
		error("<<"..s..">>")
	end
	return s
end

local function DigitCount(n)
	local b=n<0 and 2 or 1
	if math.abs(n)<10 then
		return b
	else
		return b+math.floor(math.log10(math.abs(n)))
	end
end

local function echo(...)
	if stdout then
		print(...)
	end
	AddLine(tostring(...),{255,192,192})
end

local function GetIpPort(...)
	local ip,port=...
	ip2,port2=string.match(... or "","([^%:]*):([^%:]*)")
	if port2 then
		ip=ip2
		port=port2
	end
	if type(port)=="string" and port:match("(%d+)") then
		port=tonumber(port:match("(%d+)"))
	end
	if type(ip)=="string" then
		if ip:match("(%d+%.%d+%.%d+%.%d+)") then
			ip=ip:match("(%d+%.%d+%.%d+%.%d+)")
		else
			ip=socket.dns.toip(ip) or ip
		end
	end
	return ip,port
end

local function Serve(...)
	if udp then
		udp:close()
		udp=nil
	end
	udp=udp or socket.udp()
	udp:settimeout(packet_timeout)
	local ip,port=GetIpPort(...)
	local ok,msg=pcall(udp.setsockname,udp,ip or "*",port or default_port)
	local rip,rport=nil,nil
	if ok then
		udp:settimeout(packet_timeout)
		Receive=function()
			local ok,data,ip,port=pcall(udp.receivefrom,udp)
			if ok then
				if data and ip and port then
					if not rip and not rport then
						AddLine("A client connected via "..tostring(ip)..":"..tostring(port))
					end
					rip=ip
					rport=port
					return data
				end
			else
				echo("Error Serve : "..data)
				Receive=false
			end
			return nil
		end
		Send=function(data)
			if rip and rport then
				local ok,msg=pcall(udp.sendto,udp,data,rip,rport)
				if not ok then
					Send=false
					echo("Error SendTo : "..msg)
				end
			end
		end
		local gip,gport=udp:getsockname()
		AddLine("Serve at "..tostring(ip)..":"..tostring(port).." ("..tostring(gip)..":"..tostring(gport)..")")
		return true
	else
		AddLine("Error while setting Serve : "..msg)
		return false
	end
end

local function Peer(...)
	if udp then
		udp:close()
		udp=nil
	end
	udp=udp or socket.udp()
	udp:settimeout(packet_timeout)
	local ip,port=GetIpPort(...)
	local ok,msg=udp:setpeername(ip or "",port or default_port)
	if ok then
		local gip,gport=udp:getpeername()
		AddLine("Peering to "..tostring(ip)..":"..tostring(port).." ("..tostring(gip)..":"..tostring(gport)..")")
		Send=function(data)
			local ok,msg=pcall(udp.send,udp,data)
			if not ok then
				Send=false
				echo("Error Peer Send : "..msg)
			end
		end
		Receive=function(data)
			local ok,data=pcall(udp.receive,udp)
			if ok then
				return data
			else
				Receive=false
				echo("Error Listen Receive : "..data)
				return nil
			end
		end
		return true
	else
		AddLine("Error while setting peer : "..msg)
		Send=false
		Receive=false
		return false
	end
end

local function Host(...)
	if Serve(...) then
		master=true
		slave=false
		human=2
		AddLine("Connected as Master")
	end
end

local function Join(...)
	local ip,port=GetIpPort(...)
	if not ip then
		echo("Join requires an IP! For exemple: join 127.0.0.1")
	elseif Peer(ip,port) then
		slave=true
		master=false
		human=1
		AddLine("Connected as Slave")
	end
end

local function SetTimeOut(...)
	packet_timeout=tonumber(...) or 0
	if udp then
		udp:settimeout(packet_timeout)
	end
	AddLine("Setting timeout of future "..(udp and "and current " or "").."connection to "..packet_timeout)
end

local function Close()
	Send=false
	Receive=false
	if udp then
		udp:close()
		udp=nil
	end
	AddLine("Connection Closed")
end

local function Quit()
	if love.event.quit then
		love.event.quit() -- 0.8.0
	else
		love.event.push('q') -- 0.7.2
	end
end

local function ShowHelp()
	AddLine("Not Initialised yet")
end

local ConsoleCommands={
		{ShowHelp,"help","h","?","Display the list of console commands"},
		{Join,"join","client","Connect to <Ip:Port> as client"},
		{Host,"host","server","Connect to <Ip:Port> as server"},
		{Close,"close","Close UDP connection"},
		{Quit,"exit","quit","Exit the program"},
		--{SetTimeOut,"settimeout","Change the timeout to <seconds>"},
	}

ShowHelp=function()
	for _,command in ipairs(ConsoleCommands) do
		local txt=nil
		for kwi=2,#command-1 do
			txt=(txt and txt..", " or "")..command[kwi]
		end
		txt=txt.." : "..command[#command]
		AddLine(txt)
	end
	AddLine("Anything else : Chat")
end
ConsoleCommands[1][1]=ShowHelp

local function CommandCheck(str)
	for _,command in ipairs(ConsoleCommands) do
		for kwi=2,#command-1 do
			local match=(str.." "):match("^[%s]*[%/%\\%!%.]?[%s]*"..(command[kwi]).."[%s]+(.*)")
				or (str.." "):lower():match("^[%s]*[%/%\\%!%.]?[%s]*"..(command[kwi]:lower()).."[%s]+(.*)")
			if match then
				local ok,msg=pcall(command[1],match)
				if not ok then
					echo("Error executing command \""..command[kwi].."\" : "..msg)
				end
				return true
			end 
		end
	end
	return false
end

local function GetTimeWave(period,offset)
	local period = period or 5
	local offset = (offset or 0)+period/2
	return 2*math.abs(((TotalTime+offset)/period)%1-1/2)
end

local function BiWave(amplitude,period,offset)
	return 2*amplitude*(GetTimeWave(period,offset)-0.5)
end

function love.load()

	if love.event.quit then
		-- Then we are running 0.8.0 instead of 0.7.2
		--love.graphics.print = function( text, x, y, r, sx, sy, ox, oy, kx, ky )
		--	return nil
		--	return love.graphics.print( text or "", x or 0, y or 0, r or 0, sx or 1, sy or 1, ox or 0, oy or 0, kx or 0, ky or 0)
		--end
	end

	love.graphics.setCaption("Super Extreme BayWatch VolleyBall 2012 Edition - Release 5")
	--love.mouse.setVisible(false) -- make default mouse invisible
	--love.mouse.setGrab(true)
	love.graphics.setMode(1000,700)
	love.graphics.setColor(255,255,255,255)
	love.graphics.setBackgroundColor(128,128,128)
	Font12 = love.graphics.newFont(12)
	Font24 = love.graphics.newFont(24)
	Font48 = love.graphics.newFont(48)
	love.graphics.setFont(Font12)

	-- Background textures
	grass=love.graphics.newImage("img/grass.png")
	net=love.graphics.newImage("img/net.png")
	balltex=love.graphics.newImage("img/ball.png")
	for _,b in ipairs(balls) do
		b.tex=balltex
	end

	-- Body of player 1
	local body={}
	body.crotch={x=0,y=0,a=0}
	body.torso={parent="crotch",x=0,y=0,a=0,u=0,v=-1,tex=true}
	body.legs={parent="crotch",x=0,y=0,a=0,u=0,v=1,tex=true}
	body.head={parent="torso",x=9,y=74,a=0,u=0,v=-1,tex=true}
	body.shoulder={parent="torso",x=-1,y=61,a=0,u=0,v=0.7,tex=true}
	body.forearm={parent="shoulder",x=-5,y=-41,a=0,u=0.65,v=0.1,tex=true}
	body.hand={parent="forearm",x=41.29,y=-1,a=0,u=0,v=0}
	players[1].body=body

	-- Body of player 2
	players[2].body={}
	for key,value in pairs(players[1].body) do
		players[2].body[key]={}
		for k,v in pairs(value) do
			players[2].body[key][k]=v
		end
		players[2].body[key].x=-players[1].body[key].x
		if value.u then
			players[2].body[key].u=-players[1].body[key].u
		end
	end

	-- Put player sign
	-- Remove the quotes around parents
	-- Load player body parts texture
	for k,p in ipairs(players) do
		p.sign=2*(k%2)-1
		for n,m in pairs(p.body) do
			if m.parent then
				m.parent=p.body[m.parent]
			end
			if m.tex then
				m.tex=love.graphics.newImage("img/"..n..k..".png")
			end
		end
	end
	stdout=false

end


local function DrawMiddle(tex,x,y,a,u,v,s)
	local s=s or 1
	love.graphics.translate(x,y)
	love.graphics.rotate(rad(a))
	love.graphics.scale(s,s)

	if tex then
		love.graphics.draw(tex,((u or 0)-1)*tex:getWidth()/2,((v or 0)-1)*tex:getHeight()/2)
	end

	if devmode then
		love.graphics.setColor(blink and 255 or 0,blink and 255 or 0,blink and 255 or 0,255)
		love.graphics.point(0,0)
	end
	love.graphics.setColor(255,255,255,255)

	love.graphics.scale(1/s,1/s)
	love.graphics.rotate(-rad(a))
	love.graphics.translate(-x,-y)
end


local function GetPartPos(p)
	local px,py,pa=0,700,0
	if p.parent then
		px,py,pa=GetPartPos(p.parent)
	end
	local x=px+p.x*cos(pa)+p.y*sin(pa)
	local y=py+p.x*sin(pa)-p.y*cos(pa)
	if p==shoulder then
		x=x+BiWave(1.7,3.2,1)
		y=y+BiWave(1.7,2.8,2)
	end
	return x,y,pa+p.a
end

local function DrawBodyPart(p)
	local x,y,a=GetPartPos(p)
	DrawMiddle(p.tex,x,y,a,p.u,p.v,1/3)
end

local function DrawPlayer(player)

	player.body.crotch.x=player.x
	player.body.crotch.y=player.y

	if not player.death then
		player.body.torso.a=BiWave(3,2.7,31)
		local xhead,yhead=GetPartPos(player.body.head)
		local ahead=atan2(balls[1].y-yhead,(balls[1].x-xhead)*(player.sign))
		if ahead>180 then
			ahead=ahead-180
		end
		ahead=math.max(-45,math.min(30,ahead/3))
		player.body.head.a=BiWave(7,3.8,4.5)+(player.sign)*ahead
		player.body.legs.a=BiWave(8,1.9,2.3)
		player.body.shoulder.a=player.h1+BiWave(8,2.3,0.3)
		player.body.forearm.a=player.h2-player.sign*90-BiWave(8,2.3,0.3)+BiWave(4,3.1,0.7)
	end

	DrawBodyPart(player.body.head)
	DrawBodyPart(player.body.torso)
	DrawBodyPart(player.body.legs)
	DrawBodyPart(player.body.forearm)
	DrawBodyPart(player.body.shoulder)
	DrawBodyPart(player.body.hand)

end

function love.draw()
	love.graphics.setBlendMode("alpha")
	love.graphics.setBackgroundColor(255-255*GetTimeWave(120,0),255*GetTimeWave(120,0),255)
	love.graphics.setColor(255,255,255,255)
	love.graphics.draw(grass,0,love.graphics.getHeight()-grass:getHeight())
	love.graphics.draw(net,love.graphics.getWidth()/2-net:getWidth()/2,love.graphics.getHeight()-grass:getHeight()-net:getHeight())

	for _,p in ipairs(players) do
		DrawPlayer(p)
	end

	for _,b in ipairs(balls) do
		DrawMiddle(b.tex,b.x,b.y,b.a,0,0,b.s)
	end

	love.graphics.setFont(Font12)
	love.graphics.setColor(0,0,0,255)
	love.graphics.print("Move with arrow keys",8,love.graphics.getHeight()-78)
	love.graphics.print("Flex arm with mouse",8,love.graphics.getHeight()-66)
	local function PrintHelpTable(HelpTable,y)
		for ocn,oc in ipairs(HelpTable) do
			love.graphics.print(oc,8+(ocn-1)*999/#HelpTable,love.graphics.getHeight()-y)
		end
	end
	PrintHelpTable({"Other keys:","S: change side","space: reset","p/pause: pause","d: debug mode","esc: quit"},42)
	love.graphics.print("Enter: Bring the chat/console. Inside type help for a list of commands, including \"Host\" and \"Join <IP>\"",96,love.graphics.getHeight()-18)

	love.graphics.setColor(64,64,0,255)
	love.graphics.print("A game by zwzg, for the \"Make Something Horrible\" CanardPC contest.",550,love.graphics.getHeight()-78)

	if devmode then
		love.graphics.setFont(Font12)
		love.graphics.setColor(255,255,255,255)
		love.graphics.print("T="..round(TotalTime).."  P"..human
			.."  pos:  x="..round(players[human].x).."  y="..round(players[human].y)
			.."  shoulder="..round(players[human].h1).." elbow="..round(players[human].h2),0,0)
		local ballstext=nil
		for _,b in ipairs(balls) do
			ballstext=(ballstext and ballstext.."   " or ((#balls==1 and "ball" or #balls.." balls")..":"))
				.." x="..round(b.x).."+"..round(b.dx).." y="..round(b.y).."+"..round(b.dy)
		end
		love.graphics.print(ballstext,0,16)
		love.graphics.print("FPS="..round(1/DeltaTime),0,32)
		--echo("<<"..PrefixBySpaces(round(1/DeltaTime),4)..">>")
		love.graphics.setFont(Font24)
		love.graphics.setColor(255,160,0,255)
		love.graphics.print(players[1].score,32,love.graphics.getHeight()-30)
		love.graphics.print(players[2].score,968-18*DigitCount(players[2].score),love.graphics.getHeight()-30)
	else
		love.graphics.setFont(Font48)
		love.graphics.setColor(255,255,255,255)
		love.graphics.print(players[1].score,48,24)
		love.graphics.print(players[2].score,952-36*DigitCount(players[2].score),24)
	end
	love.graphics.setFont(Font12)
	love.graphics.setColor(255,255,255,255)

	-- Draw edit box
	if focus then
		local color=focus.color or {}
		for c=1,4 do
			color[c]=color[c] or 255
		end
		love.graphics.setFont(focus.font)
		love.graphics.setColor(unpack(color))
		love.graphics.print(
			(focus.prompt or "")..focus.text:sub(1,focus.pos).."|"..focus.text:sub(focus.pos+1),
			focus.x,focus.y)
	end

	-- Draw chat/console
	love.graphics.setFont(Font12)
	local time=love.timer.getTime()
	for index,entry in ipairs(chat.buffer) do
		local color=entry.color or {}
		for c=1,4 do
			color[c]=color[c] or 255
		end
		love.graphics.setColor(unpack(color))
		love.graphics.print(entry.text,48,96+12*index)
		if time-entry.time>chat.timeout then
			table.remove(chat.buffer,index)
		end
	end

end

local function UpdateGame(dt)

	players[1].x=math.max(20,math.min(450,players[1].x))
	players[2].x=math.min(980,math.max(550,players[2].x))
	for _,p in ipairs(players) do
		p.y=math.max(ground,math.min(375,p.y-60*dt))
		local x,y=GetPartPos(p.body.hand)
		if not p.lasthand then
			p.lasthand={}
			for k=1,10 do
				p.lasthand[k]={x=x,y=y,t=0}
			end
		end
		table.insert(p.lasthand,1,{x=x,y=y,t=TotalTime})
		table.remove(p.lasthand)
		if p.death then
			local t=(TotalTime-p.death)/4
			for _,p in pairs(p.body) do
				if not p.sx then
					p.sx=p.x
					p.sy=p.y
					local a=math.random(0,360)
					p.dx=cos(a)
					p.dy=sin(a)
				end
				p.x=p.sx+800*p.dx*t^3
				p.y=p.sy+800*p.dy*t^3
				p.a=120*t^3
			end
			if t>1 then
				for _,p in pairs(p.body) do
					p.a=0
					p.x=p.sx
					p.y=p.sy
					p.sx=nil
					p.sy=nil
					p.dx=nil
					p.dy=nil
					p.ex=nil
					p.ey=nil
				end
				p.death=nil
				for _,b in ipairs(balls) do
					b.x=500-200*p.sign+math.random()/50-0.01
					b.y=50
					b.dx=0
					b.dy=0
				end
			end
		end
	end

	for _,b in ipairs(balls) do
		b.x=b.x+b.dx*dt
		b.y=b.y+b.dy*dt
		b.a=b.a+b.da*dt
		b.dy=b.dy+40*dt
		local r=b.tex:getHeight()*b.s/2
		if b.y+r>love.graphics.getHeight()-84 then
			b.dy=-math.min(500,((#balls==1) and 0.9 or 1.1)*math.abs(b.dy))
			b.da=200*(2*math.random()-1)
			local p=b.x<500 and 1 or 2
			if not players[p].death then
				players[3-p].score=players[3-p].score+1
				if math.max(players[1].score,players[2].score)>(#balls==1 and 20 or 10^#balls) then
					balls[#balls+1]={}
					for k,v in pairs(b) do
						balls[#balls][k]=v
					end
					balls[#balls].x=balls[#balls].x-0.05
				elseif #balls==1 then
					players[p].death=TotalTime
				end
			end
		end
		if b.y-r<0 then
			b.dy=-b.dy
			b.y=r-b.y
		end
		if b.x-r<0 or b.x+r>love.graphics.getWidth() then
			b.dx=math.abs(b.dx)
		end
		if b.x+r>love.graphics.getWidth() then
			b.dx=-math.abs(b.dx)
		end
		if b.x+r>love.graphics.getWidth()/2-net:getWidth()/2 and b.x-r<love.graphics.getWidth()/2+net:getWidth()/2 and b.y+r>love.graphics.getHeight()-grass:getHeight()-net:getHeight() then
			b.dx=-b.dx
		end
		for _,p in ipairs(players) do
			if not p.death then
				local x,y=p.lasthand[1].x,p.lasthand[1].y
				if (b.x-x)*(b.x-x)+(b.y-y)*(b.y-y)<r*r then
					local lh=p.lasthand
					local n=#lh
					local fx,fy=(x-lh[n].x)/(lh[1].t-lh[n].t),(y-lh[n].y)/(lh[1].t-lh[n].t)
					b.dx=2*fx
					b.dy=2*fy
					local f=math.sqrt(fx^2+fy^2)
					--b.x=b.x+20*fx/f
					--b.y=b.y+20*fy/f
					b.da=7*f*(2*math.random()-1)
				end
			end
		end

	end

end


local function ManageBot(dt)
	if master or slave then
		return
	end

	local d=dt*100

	-- Get feet intention
	local bot=players[3-human]
	local wh1,wh2=20*bot.sign,90*bot.sign
	local wx,ob=nil,nil
	local sd=function(b) return (b.y-450)^2+(b.x-50*bot.sign)^2 end
	for _,b in ipairs(balls) do
		if b.dy>0 then
			local bwx=b.x
			if b.y<350 then
				bwx=b.x+(350-b.y)/b.dy*b.dx
			end
			if (bwx>500)==(bot.x>500) then
				if not ob or sd(b)<sd(ob) then
					wx=bwx-50*bot.sign
					ob=b
				end
			end
		end
	end
	if not wx then
		if bot.x>500 then
			wx=772
		else
			wx=228
		end
	end

	-- Get hand intention
	local xivot,yivot=GetPartPos(bot.body.shoulder)
	for _,b in ipairs(balls) do
		local hand2ball_distance=math.sqrt((b.x-xivot)^2+(b.y-yivot)^2)
		local hand2ball_angle=atan2(b.y-yivot,bot.sign*(b.x-xivot))
		if hand2ball_distance<82 then
			wh2=bot.sign*2*math.asin(hand2ball_distance/82)*180/math.pi
			wh1=bot.sign*hand2ball_angle-wh2/2+0*(bot.sign<0 and 180 or 0)
		end
	end

	-- Update with physical slowness
	if wx>bot.x+d then
		bot.x=bot.x+d
	elseif wx<bot.x-d then
		bot.x=bot.x-d
	end
	bot.h1=bot.h1+math.min(10,math.max(-10,wh1-bot.h1))
	bot.h2=bot.h2+math.min(10,math.max(-10,wh2-bot.h2))

end


local function ReceiveNetworkData()
	if Receive then
		repeat
			local data=Receive()
			if data then
				if devmode then
					AddLine("received:\""..data.."\"")
				end
				local chat=data:match("^chat:(.*)")
				if chat then
					AddLine("Him: "..chat,{255,240,200})
				end
				local rectime=data:match("t:([^%s%:]*)")
				if ((master and rectime) or (slave and not rectime)) and not chat then
					data=""
				end
				local recballs=data:match("balls:([^%s%:]*)")
				if recballs then
					if slave then
						recballs=loadstring("return "..recballs)()
						while #recballs>#balls do
							balls[#balls+1]={}
							for k,v in pairs(balls[1]) do
								balls[#balls][k]=v
							end
						end
						while #recballs<#balls do
							table.remove(balls)
						end
						for b,ball in ipairs(recballs) do
							for k,v in pairs(ball) do
								balls[b][k]=v
							end
						end
					end
				end
				local recplayer=data:match("player:([^%s%:]*)")
				if recplayer then
					local recplayer=loadstring("return "..recplayer)()
					for k,v in pairs(recplayer) do
						if k=="death" then
							v=v/100+TotalTime
							if master and not players[3-human]["death"] then
								v=nil
							end
						end
						players[3-human][k]=v
					end
				end
				local score1,score2=data:match("score%:(%d+)%,(%d+)")
				if score1 and score2 then
					--players[1].score=math.max(players[1].score,tonumber(score1))
					--players[2].score=math.max(players[2].score,tonumber(score2))
					players[1].score=tonumber(score1)
					players[2].score=tonumber(score2)
				end
			end
		until not data
	end
end

local function SendNetworkData()
	if Send then
		data=""
		if master then
			data="t:"..math.floor(TotalTime+0.5)
			data=data.." score:"..players[1].score..","..players[2].score.." balls:{"
			for _,b in ipairs(balls) do
				data=data.."{"
				for k,v in pairs(b) do
					if type(v)=="number" and k=="x" or k=="y" then
						data=data..k.."="..math.floor(v+0.5)..","
					end
				end
				data=data.."},"
			end
			data=data.."} "
		end
		data=data.." player:{"
		for k,v in pairs(players[human]) do
			if type(v)=="number" then
				if k=="death" then
					v=100*(v-TotalTime)
				end
				if k~="score" then
					data=data..k.."="..math.floor(v+0.5)..","
				end
			end
		end
		data=data.."}"
		Send(data)
	end
end

local function EditBoxControls(key,unicode)
	if key:sub(1,2)=="kp" then
		key=key:sub(3)
	end
	if key=="return" or key=="enter" then
		focus:complete()
		focus=nil
	elseif key=="escape" then
		focus=nil
	elseif key=="left" then
		focus.pos=math.max(0,focus.pos-1)
	elseif key=="right" then
		focus.pos=math.min(focus.text:len(),focus.pos+1)
	elseif key=="delete" then
		focus.text=focus.text:sub(1,focus.pos)..focus.text:sub(focus.pos+2)
	elseif key=="backspace" then
		focus.text=focus.text:sub(1,focus.pos-1)..focus.text:sub(focus.pos+1)
		focus.pos=math.max(0,focus.pos-1)
	elseif key=="up" or key=="home" then
		focus.pos=0
	elseif key=="down" or key=="end" then
		focus.pos=#focus.text
	elseif key=="shift" or key=="rshift" or key=="lshift" then
		-- nothing
	elseif key=="capslock" then
		--focus.capslock=not focus.capslock
	else
		if unicode~=0 then
			key=string.char(unicode)
		end
		if love.keyboard.isDown("shift") then
			--if focus.capslock then
				key=key:upper()
			--else
			--	key=key:lower()
			--end
		end
		focus.text=focus.text:sub(1,focus.pos)..key..focus.text:sub(focus.pos+1)
		focus.pos=focus.pos+key:len()
	end
end

function love.keypressed(key,unicode)
	if focus then-- When in an edit box :
		EditBoxControls(key,unicode)
	else-- When ingame :
		if key=="escape" then
			Quit()
		end
		if key=="c" then
			stdout=not stdout
		end
		if key=="s" and not (master or slave) then
			human=3-human
		end
		if key=="d" then
			devmode=not devmode
		end
		if key=="p" or key=="pause" then
			pause=not pause
		end
		if key=="return" then
			focus={font=Font24,prompt="> ",text="",pos=0,x=24,y=72,color={192,255,192},
				complete=function(self)
					if not CommandCheck(self.text) then
						AddLine("You: "..self.text,{224,255,224})
						if Send then
							Send("chat:"..self.text)
						end
					end
				end
			}
		end
	end
end


local function ManageKeys(dt)
	local d=dt*100
	if focus then
		return
	end
	if love.keyboard.isDown("up") then
		players[human].y=players[human].y+d*2
	end
	if love.keyboard.isDown("down" )then
		players[human].y=players[human].y-d*2
	end
	if love.keyboard.isDown("left") then
		players[human].x=players[human].x-d
	end
	if love.keyboard.isDown("right") then
		players[human].x=players[human].x+d
	end
	if love.keyboard.isDown("pageup") then

	end
	if love.keyboard.isDown("pagedown") then

	end
	--if love.keyboard.isDown("r") then
	--	balls={{x=300,y=50,a=0,s=0.5,dx=0,dy=0,da=-90,tex=balltex}}
	--end
	if love.keyboard.isDown(" ") then
		for _,p in ipairs(players) do
			p.score=0
			p.death=p.death and -5
		end
		while #balls~=1 do
			table.remove(balls)
		end
		TotalTime=0
	end
end

local function ManageMouse(dt)
	local p=players[human]
	local h1,h2
	local mx,my = love.mouse.getPosition()
	local xivot,yivot=GetPartPos(p.body.shoulder)
	local hand2mouse_distance=math.sqrt((mx-xivot)^2+(my-yivot)^2)
	local hand2mouse_angle=atan2(my-yivot,p.sign*(mx-xivot))
	if hand2mouse_distance>82 then
		h2=p.sign*180
	else
		h2=p.sign*2*math.asin(hand2mouse_distance/82)*180/math.pi
	end
	h1=p.sign*hand2mouse_angle-h2/2+0*(p.sign<0 and 180 or 0)
	p.h1=p.h1+math.min(10,math.max(-10,h1-p.h1))
	p.h2=p.h2+math.min(10,math.max(-10,h2-p.h2))
end

local cdt = 0

function love.update(dt)

	-- Manage Multiplayer 1/2
	ReceiveNetworkData()

	if pause and not (master or slave) then
		return
	end

	DeltaTime = dt
	TotalTime = TotalTime+dt
	cdt = cdt + dt

	if math.floor(2*TotalTime)~=math.floor(2*(TotalTime-cdt)) then
		blink=not blink
	end

	-- Character control
	ManageKeys(cdt)
	ManageMouse(cdt)

	-- IA control
	ManageBot(cdt)

	-- Update stuff
	UpdateGame(cdt)

	-- Manage Multiplayer 2/2
	SendNetworkData()

	cdt=0

	if love.event.quit then
		love.timer.sleep(0.030) -- 0.8.0
	else
		love.timer.sleep(30) -- 0.7.2
	end


end














